(* L3 compiler
 * stringifier
 * turns a list of x86 insns into the assembly code to generate them
 * Author: Chris Lu <czl@andrew.cmu.edu>
 *)

signature STRINGIFY =
sig
  type asm = x86.insn list
  val stringify : (string -> string) -> asm -> string
end

structure Stringify :> STRINGIFY =
struct
  type asm = x86.insn list
  structure X = x86

  (* val stringify : asm -> string
   * turns a x86 instruction list into a string of assembly code for these instructions *)

  fun stringify' rn (X.CALL (l, n)) = X.prettyprint (X.CALL ((Symbol.symbol (rn (Symbol.name l))), n))
    | stringify' rn x = X.prettyprint x

  (* val stringify : asm -> string *)
  fun stringify realname l = foldr (fn (a,b) => (stringify' realname a) ^ b) ("") l

end
